<?php 
#################################################################
#                                                               #
#  Novalnet module                                              #
#  This module is used for real time processing of              #
#  Novalnet transaction of customers.                           #
#  Released under the GNU General Public License                #
#  This free contribution made by request.                      #
#  If you have found this script usefull a small                #
#  recommendation as well as a comment on merchant form         #
#  would be greatly appreciated.                                #
#                                                               #
#  Script : uc_novalnet.pages.inc                               #
#                                                               #
#################################################################

    define('UC_PAYMENT_TYPES' , serialize (array(
                'novalnet_invoice'     => array('INVOICE_CREDIT','INVOICE_START','SUBSCRIPTION_STOP'),
                'novalnet_prepayment'  => array('INVOICE_CREDIT','INVOICE_START','SUBSCRIPTION_STOP'),
                'novalnet_paypal'      => array('PAYPAL'),
                'novalnet_instantbank' => array('ONLINE_TRANSFER'),
                'novalnet_cc'          => array('CREDITCARD', 'CREDITCARD_BOOKBACK','CREDITCARD_CHARGEBACK','SUBSCRIPTION_STOP'),
                'novalnet_sepa'        => array('DIRECT_DEBIT_SEPA','RETURN_DEBIT_SEPA','SUBSCRIPTION_STOP'),
                'novalnet_ideal'       => array('IDEAL')
                )));
    define('PAYMENT_TYPES' , serialize (array('INVOICE_CREDIT', 'INVOICE_START', 'PAYPAL', 'ONLINE_TRANSFER', 'CREDITCARD', 'CREDITCARD_BOOKBACK', 'IDEAL', 'DIRECT_DEBIT_SEPA')));
    define('INVOICE_ALLOWD' , serialize (array('INVOICE_CREDIT','INVOICE_START')));
    define('RECURRING_ALLOWD' , serialize (array('INVOICE_CREDIT','CREDITCARD', 'DIRECT_DEBIT_SEPA', 'SUBSCRIPTION_STOP')));
    define('CHARGE_BACK', serialize (array('CREDITCARD_CHARGEBACK', 'RETURN_DEBIT_SEPA')));
    define('NN_IP' ,'195.143.189.210');
    define('LINEBREAK', empty($_SERVER['HTTP_HOST']) ? PHP_EOL : '<br />');

    function uc_novalnet_callbackscript(){
      watchdog('Novalnet Callbackscript', 'Novalnet Callback Script executed on '. date("d.m.Y H:i:s") .'Uhr for TID' . $_REQUEST['tid'] . ', Order ID is' . $_REQUEST['order_no']. ' From IP' . ip_address());
      $cbk_data = array('cbk_mail_from'  => variable_get('uc_novalnet_frommail', ''),
                      'cbk_mail_to'      => variable_get('uc_novalnet_tomail', ''),
                      'cbk_mail_subject' => variable_get('uc_novalnet_emailsubject', ''),
                      'cbk_mail_body'    => variable_get('uc_novalnet_emailbody', ''),
                      'test'             => variable_get('uc_novalnet_callback_testmode', 0),
                      'debug'            => variable_get('uc_novalnet_callback_debugmode', 0),
                      'cbk_mail_send'    => variable_get('uc_novalnet_callback_sendmail', 0),
                     ); 
      $url_request = array_map('check_plain', $_REQUEST);
      $url_request = array_map('trim', $_REQUEST);
      $cbk_data['test'] = $cbk_data['debug'] = false;
      if(isset($url_request['debug_mode']) && $url_request['debug_mode'] == 1){
         $cbk_data['test'] = true;
         $cbk_data['debug'] = true;
      }
      if(check_ipaddr($cbk_data, $url_request)){
        $order = '';
        if(check_params($cbk_data, $url_request, $order)){
           set_order_status($url_request, $order, $cbk_data);
        }
      }
    }

    function check_ipaddr(&$cbk_data, $url_request){
      if( $cbk_data['debug'] || NN_IP ==  ip_address()){
        return true;
      }
      echo t('Novalnet callback received').' '.t('Unauthorised access from the IP [') . ip_address() . ']';
      return false;
    }

    function check_params($cbk_data, &$url_request, &$order){ 
      if(empty($url_request)){
        echo t('Novalnet callback received.').' '.t('No params passed over!');
      }
      $required_params = array('vendor_id' => '' , 'tid' => '' , 'payment_type' => '' , 'status' => '' , 'amount' => '' , 'tid_payment' => '' , 'signup_tid' => '' );
      if(isset($url_request['subs_billing']) && $url_request['subs_billing'] == 1 ){
         $url_request['cbk_type'] = 'recurring';
         unset($required_params['tid_payment']);
      }else{
         $url_request['cbk_type'] = 'callback'; 
         unset($required_params['signup_tid']);
      }
      if(isset($url_request['payment_type']) && in_array($url_request['payment_type'], unserialize(CHARGE_BACK))){
         unset($required_params['signup_tid']);
         $url_request['cbk_type'] = 'chargebck';
      }
      switch ($url_request['cbk_type']){
         case 'recurring':
               $url_request['org_tid'] = (isset($url_request['signup_tid']) && ($url_request['cbk_type'] == 'recurring')) ? $url_request['signup_tid'] :'';
               break;
         case 'callback':
               if(isset($url_request['payment_type']) && in_array($url_request['payment_type'], unserialize(INVOICE_ALLOWD))){
                 $url_request['org_tid'] = (isset($url_request['tid_payment'])) ? $url_request['tid_payment'] :'';
               } else{
                 $url_request['org_tid'] = (isset($url_request['tid'])) ? $url_request['tid'] :'';
                 unset($required_params['tid_payment']);
               }
               break;
         case 'chargebck':
               $url_request['org_tid'] = (isset($url_request['tid_payment']) && ($url_request['cbk_type'] == 'chargebck')) ? $url_request['tid_payment']:'';
               break;
      }
      $error_msg = '';
      foreach($required_params as $key => $val){
        if(!isset($url_request[$key]) || empty($url_request[$key])){
           $error_msg .= t('Novalnet callback received.').' '.t('Required param missing!'). ' - '. $key .LINEBREAK;
        }
      }
      if(!empty($error_msg)){
         if($cbk_data['debug']) echo $error_msg;
         return false;
      }
      $order = validate_param($url_request, $required_params, $error_msg, $cbk_data); 
      if(!$order){
         if($cbk_data['debug']) echo $error_msg;
         return false;
      }
      return true;
    }

    function validate_param($url_request, $required_params, &$error_msg, $cbk_data){
      $tid_arry = array('tid', 'signup_tid', 'tid_payment');
      foreach($tid_arry as $key){
        if(isset($required_params[$key])){ 
           if(strlen($url_request[$key]) != 17 || preg_match('/^[^0-9]$/' , $url_request[$key])){
               $error_msg .= t('Novalnet callback received.').' '.t('Invalid  '). ucwords($key). ' - '. $url_request[$key]. LINEBREAK;
            }
        }
      }
      if(!empty($error_msg)) return false;
      if (!preg_match('!^[1-9][0-9]*$!', $url_request['amount'])){
         $error_msg .= t('Novalnet callback received.').' '.t('Order amount should be greater than zero').LINEBREAK;
         return false;
      }
      $transDetails = db_select('uc_order_comments', 'arg')
                          -> fields('arg', array('order_id'))
                          -> condition('message', '%'. $url_request['org_tid'] .'%' ,'like')
                          -> execute()-> fetchObject();
      if(!empty($url_request['order_no']) && !empty($transDetails) && $transDetails->order_id != $url_request['order_no']){
         $error_msg .= t('Novalnet callback received.').' '.t('Order no is not valid!.').LINEBREAK;
         return false; 
      }
      
      $order = uc_order_load($transDetails->order_id);
      $paymenttypes = unserialize(UC_PAYMENT_TYPES);
      if(!in_array($url_request['payment_type'], $paymenttypes[$order->payment_method])){
         $error_msg .= t('Novalnet callback received.').' '.t('Payment type Mismatched!').LINEBREAK;
         return false;
      }
      return $order;
    }
    function uc_novalnet_cbk_mail($cbk_data, $messages) {
        $messages['mail_msg'] = isset($messages['mail_msg']) ? $messages['mail_msg'] : '';
        global $language;
        if(empty($cbk_data['debug'])) $cbk_data['cbk_mail_body'] .= LINEBREAK . LINEBREAK . LINEBREAK ;
        $cbk_data['cbk_mail_body'] .= t('Novalnet Callback script Details  as follows'). LINEBREAK . $messages['mail_body'];
        $params['subject'] = isset($cbk_data['cbk_mail_subject']) ? $cbk_data['cbk_mail_subject'] : t('Novalnet Callback Script Access Report');
        $params['body'] = t('Dear Customer,'). LINEBREAK . LINEBREAK . $cbk_data['cbk_mail_body'] . LINEBREAK . LINEBREAK . t('Regards,'). LINEBREAK. 'Novalnet AG';
        $mailreslt = drupal_mail('uc_novalnet', 'nn_callback', $cbk_data['cbk_mail_to'], $language -> language, $params, $cbk_data['cbk_mail_from'], TRUE); 
        if ($cbk_data['debug'] || $mailreslt['result'] == 1) echo '<meta content="text/html; charset=utf-8" http-equiv="Content-Type">'. t('Sending Email succeeded!'). LINEBREAK.LINEBREAK. $cbk_data['cbk_mail_body'] . $messages['mail_msg'];
    } 

    function set_order_status($url_request, $order, $cbk_data){ 
        $currency = $order->currency;
        $amount   = sprintf('%0.2f', $url_request['amount']/100).' '.$currency; 
        $messages = array('error' => '', 'mail_body' =>'', 'comment' => '');
        if ($url_request['status'] == 100) {  
          switch ($url_request['cbk_type']){ 
            case 'recurring': 
               recurring_update($order, $url_request, $messages, $amount);
               break;
            case 'callback':
               callback_update($order, $url_request, $messages, $amount);
               break;
            case 'chargebck':
              chargebck_update($order, $url_request, $messages, $amount);
              break;
          }
        }else{
          $messages['error'] .= t('Novalnet callback received.').' '.t('Order - got completed already. Refer Order :') . $order->order_id .LINEBREAK;
        }
        if(!empty($messages['error'])){
            if($cbk_data['debug']) echo $messages['error'];
            return false;
        }
        if(!empty($messages['mail_body']) && $cbk_data['cbk_mail_send'] == 1){
          uc_novalnet_cbk_mail($cbk_data, $messages);
          watchdog('Novalnet Callbackscript    ', $messages['mail_body']); 
        }elseif($cbk_data['debug'] && $cbk_data['cbk_mail_send'] != 1){
            echo t('Mail sending failed (Please configure the callbackscript )'). $messages['mail_body']. (isset($messages['mail_msg']) ? $messages['mail_msg'] : '' ) ;
        }
    }

    function recurring_update($order, $url_request, &$messages, $amount){
      global $base_url;
       if(!in_array($url_request['payment_type'], unserialize(RECURRING_ALLOWD))){
         $messages['error'] .= LINEBREAK . t('Novalnet callback received.').' '.t('Payment type Mismatched!');
         return false;
       }
        #### Step1: THE SUBSCRIPTION IS RENEWED, PAYMENT IS MADE, SO JUST CREATE A NEW ORDER HERE WITHOUT A PAYMENT PROCESS AND SET THE ORDER STATUS AS PAID ####

        #### Step2: THIS IS OPTIONAL: UPDATE THE BOOKING REFERENCE AT NOVALNET WITH YOUR ORDER_NO BY CALLING NOVALNET GATEWAY, IF U WANT THE USER TO USE ORDER_NO AS PAYMENT REFERENCE ###

        #### Step3: ADJUST THE NEW ORDER CONFIRMATION EMAIL TO INFORM THE USER THAT THIS ORDER IS MADE ON SUBSCRIPTION RENEWAL ###
    }

    function callback_update($order, $url_request, &$messages, $amount){ 
      if($url_request['payment_type'] == 'SUBSCRIPTION_STOP'){
         $messages['error'] .= t('Novalnet callback received.').' '.t('Payment type Mismatched!').LINEBREAK;
         return false;
      }
      $order_balance = uc_payment_balance($order); 
      $msg = '';
      if (($url_request['payment_type'] == 'INVOICE_CREDIT' && $order_balance > 0)) {
         $messages['comment'] = t('Novalnet Callback Script executed successfully for the TID:').' '. $url_request['tid_payment'] .' '.t('with amount').' '.$amount .' '.t('on').' '. date('d.m.Y H:i:s') .'. '.t('Please refer PAID transaction in our Novalnet Merchant Administration with the TID: '). $url_request['tid']. LINEBREAK;
        $comment = callback_amt_update($order, $messages['comment'], ($url_request['amount']/100));
        $order_state   = variable_get($order->payment_method.'_before_order_status');
        $order_balance = uc_payment_balance($order)*100;
        if($order_balance <= 0) 
        $order_state   =  variable_get($order->payment_method.'_after_order_status');
        if($order_balance < 0)
        $msg = ($url_request['amount'] > $order_balance) ? LINEBREAK .t('Paid amount is greater than the order amount.') : '' ;          
       } 
       elseif (!in_array($url_request['payment_type'], unserialize(INVOICE_ALLOWD)) && $order_balance > 0 ) {
         $messages['comment'] = t('Novalnet Callback Script executed successfully for the TID:').' '. $url_request['tid'] .' '.t('with amount') .' '. $order_balance .' '.t('on').' '. date('d.m.Y H:i:s').LINEBREAK;
         $comment = callback_amt_update($order, $messages['comment'], $order_balance);
         if($url_request['payment_type'] == 'PAYPAL')
         $order_state   = variable_get($order->payment_method.'_after_order_status');
       }
       else { 
         if($order->payment_method == 'novalnet_invoice')
         echo 'Order got completed already. Please refer the order id  '.$order->order_id;
         else
         echo 'Novalnet callbackscript received. Payment type ( '.$url_request['payment_type'].' ) is not applicable for this process!';
         return false;
       }
       uc_order_comment_save($order->order_id,  0,  $comment ,  'order',  $order_state, 'TRUE');
       uc_order_update_status($order->order_id, $order_state);
       $messages['mail_body'] = $messages['comment'];
       $messages['mail_msg'] = $msg;
    }

    function chargebck_update($order, $url_request, &$messages, $amount){
      $messages['mail_body'] .= LINEBREAK.t('Novalnet callback received.').' '.t('Chargeback was executed successfully TID :'). $url_request['org_tid'].' '.t("with amount").' '.$amount.' '.t("on").' '.date('d.m.Y H:i:s').LINEBREAK;
      $msg =  $messages['mail_body'];
      $updatestatus = db_query("UPDATE uc_order_comments
                                SET message = CONCAT(message,'". $msg ."')
                                WHERE order_id= " .$order->order_id ." LIMIT 1");
      return true;
    }
    
    function callback_amt_update($order, $messages, $amount){
        $value = '';
        if($order->payment_method != 'novalnet_prepayment'){    
        $result = db_select('uc_payment_receipts', 'r')
         ->fields('r', array('comment'))
         ->condition('order_id', $order->order_id)
         ->execute()
         ->fetchAssoc();
        $value = $result['comment'].LINEBREAK.LINEBREAK;    
        }       
        $comment = $value.$messages;  
        db_insert('uc_payment_receipts')
         ->fields(array(
            'order_id'  => $order->order_id,
            'method'    => $order->payment_method,
            'amount'    => $amount, 
            'uid'       => $order->uid,
            'data'      => NULL,
            'comment'   => $comment,
            'received'  => time(),
        ))
        ->execute();
        return $comment;
    }
